<?php

namespace yckj\commons\middleware;

use Closure;
use yckj\commons\model\Result;
use think\Config;
use think\Request;
use think\Response;
use think\Facade\Log;

class AutoResult
{
    /**
     * 自动转化数据为 Result
     *
     * @param Request $request
     * @param Closure $next
     * 
     * @return void
     */
    public function handle(Request $request, Closure $next)
    {
        $response = $next($request);

        $data = $response->getData();

        // 如果已经是 Result 就不动了
        if ($data instanceof Result) {
            return $response;
        }

        return $response->data(Result::of($data));
    }
}
